package eel6788.gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

import yaes.framework.world.sensornetwork.SensorNetworkWorld;
import yaes.framework.world.sensornetwork.SensorNode;
import yaes.ui.visualization.VisualMapPanel;
import yaes.ui.visualization.application.sensornetwork.PainterConfiguration;
import eel6788.agents.directeddiffusion.DirectedDiffusionSinkAgent;
import eel6788.agents.directeddiffusion.Interest;

/**
 * This is a painter for the sink node.
 * 
 * @author Lotzi Boloni
 * 
 */
public class DirectedDiffusionSinkNodePainter extends DirectedDiffusionNodePainter {
	public DirectedDiffusionSinkNodePainter(SensorNetworkWorld sensingManager,
			PainterConfiguration painterConf) {
		super(sensingManager, painterConf);
		sensorNodeSize = 10;
	}

	@Override
	public void paint(Graphics2D g, Object o, VisualMapPanel panel) {
		super.paint(g, o, panel);
		if (!(o instanceof SensorNode)) {
			return;
		}
		final SensorNode node = (SensorNode) o;
		DirectedDiffusionSinkAgent sinkAgent =
				(DirectedDiffusionSinkAgent) node.getAgent();
		for(Interest interest: sinkAgent.getInterests().values()) {
			g.setColor((Color)painterConf.get(PainterConfiguration.PCONF_TRANSMISSION_RANGE_COLOR));			
			g.setStroke(new BasicStroke());
			Rectangle2D.Double rect = interest.getRectangle();
			g.draw(rect);
		}
	}
}
